VTK: vtkImageSincInterpolator Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkImageSincInterpolator Class Reference

perform sinc interpolation on images More...

`#include <vtkImageSincInterpolator.h>`

Inheritance diagram for vtkImageSincInterpolator:
[legend]
Collaboration diagram for vtkImageSincInterpolator:
[legend]

## Public Types
typedef vtkAbstractImageInterpolator | Superclass
Public Types inherited from vtkAbstractImageInterpolator
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkImageSincInterpolator * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | SetWindowHalfWidth (int n)
| Set the window half-width, this must be an integer between 1 and 16, with a default value of 3. More...
int | GetWindowHalfWidth ()
void | SetUseWindowParameter (int val)
| Turn this on in order to use SetWindowParameter. More...
void | UseWindowParameterOn ()
void | UseWindowParameterOff ()
int | GetUseWindowParameter ()
void | SetWindowParameter (double parm)
| Set the alpha parameter for the Kaiser window function. More...
double | GetWindowParameter ()
void | ComputeSupportSize (const double matrix[16], int support[3]) override
| Get the support size for use in computing update extents. More...
void | SetAntialiasing (int antialiasing)
| Turn on antialiasing. More...
void | AntialiasingOn ()
void | AntialiasingOff ()
int | GetAntialiasing ()
void | SetRenormalization (int renormalization)
| Turn off renormalization. More...
void | RenormalizationOn ()
void | RenormalizationOff ()
int | GetRenormalization ()
bool | IsSeparable () override
| Returns true if the interpolator supports weight precomputation. More...
void | FreePrecomputedWeights (vtkInterpolationWeights *&weights) override
| Free the precomputed weights. More...
virtual void | SetWindowFunction (int mode)
| The window function to use. More...
void | SetWindowFunctionToLanczos ()
| The window function to use. More...
void | SetWindowFunctionToKaiser ()
| The window function to use. More...
void | SetWindowFunctionToCosine ()
| The window function to use. More...
void | SetWindowFunctionToHann ()
| The window function to use. More...
void | SetWindowFunctionToHamming ()
| The window function to use. More...
void | SetWindowFunctionToBlackman ()
| The window function to use. More...
void | SetWindowFunctionToBlackmanHarris3 ()
| The window function to use. More...
void | SetWindowFunctionToBlackmanHarris4 ()
| The window function to use. More...
void | SetWindowFunctionToNuttall ()
| The window function to use. More...
void | SetWindowFunctionToBlackmanNuttall3 ()
| The window function to use. More...
void | SetWindowFunctionToBlackmanNuttall4 ()
| The window function to use. More...
int | GetWindowFunction ()
| The window function to use. More...
virtual const char * | GetWindowFunctionAsString ()
| The window function to use. More...
void | SetBlurFactors (double x, double y, double z)
| Blur the image by widening the windowed sinc kernel by the specified factors for the x, y, and z directions. More...
void | SetBlurFactors (const double f[3])
| Blur the image by widening the windowed sinc kernel by the specified factors for the x, y, and z directions. More...
void | GetBlurFactors (double f[3])
| Blur the image by widening the windowed sinc kernel by the specified factors for the x, y, and z directions. More...
double * | GetBlurFactors ()
| Blur the image by widening the windowed sinc kernel by the specified factors for the x, y, and z directions. More...
void | PrecomputeWeightsForExtent (const double matrix[16], const int extent[6], int newExtent[6], vtkInterpolationWeights *&weights) override
| If the data is going to be sampled on a regular grid, then the interpolation weights can be precomputed. More...
void | PrecomputeWeightsForExtent (const float matrix[16], const int extent[6], int newExtent[6], vtkInterpolationWeights *&weights) override
| If the data is going to be sampled on a regular grid, then the interpolation weights can be precomputed. More...
Public Member Functions inherited from vtkAbstractImageInterpolator
vtkAbstractImageInterpolator * | NewInstance () const
virtual void | Initialize (vtkDataObject *data)
| Initialize the interpolator with the data that you wish to interpolate. More...
virtual void | ReleaseData ()
| Release any data stored by the interpolator. More...
void | DeepCopy (vtkAbstractImageInterpolator *obj)
| Copy the interpolator. More...
virtual void | Update ()
| Update the interpolator. More...
double | Interpolate (double x, double y, double z, int component)
| Get the result of interpolating the specified component of the input data, which should be set to zero if there is only one component. More...
bool | Interpolate (const double point[3], double *value)
| Sample the input data. More...
void | SetOutValue (double outValue)
| The value to return when the point is out of bounds. More...
double | GetOutValue ()
void | SetTolerance (double tol)
| The tolerance to apply when checking whether a point is out of bounds. More...
double | GetTolerance ()
void | SetComponentOffset (int offset)
| This method specifies which component of the input will be interpolated, or if ComponentCount is also set, it specifies the first component. More...
int | GetComponentOffset ()
void | SetComponentCount (int count)
| This method specifies the number of components to extract. More...
int | GetComponentCount ()
int | ComputeNumberOfComponents (int inputComponents)
| Compute the number of output components based on the ComponentOffset, ComponentCount, and the number of components in the input data. More...
int | GetNumberOfComponents ()
| Get the number of components that will be returned when Interpolate() is called. More...
void | SetSlidingWindow (bool x)
| Enable sliding window for separable kernels. More...
void | SlidingWindowOn ()
void | SlidingWindowOff ()
bool | GetSlidingWindow ()
void | InterpolateIJK (const double point[3], double *value)
| A version of Interpolate that takes structured coords instead of data coords. More...
void | InterpolateIJK (const float point[3], float *value)
| A version of Interpolate that takes structured coords instead of data coords. More...
bool | CheckBoundsIJK (const double x[3])
| Check an x,y,z point to see if it is within the bounds for the structured coords of the image. More...
bool | CheckBoundsIJK (const float x[3])
| Check an x,y,z point to see if it is within the bounds for the structured coords of the image. More...
void | SetBorderMode (vtkImageBorderMode mode)
| The border mode (default: clamp). More...
void | SetBorderModeToClamp ()
| The border mode (default: clamp). More...
void | SetBorderModeToRepeat ()
| The border mode (default: clamp). More...
void | SetBorderModeToMirror ()
| The border mode (default: clamp). More...
vtkImageBorderMode | GetBorderMode ()
| The border mode (default: clamp). More...
const char * | GetBorderModeAsString ()
| The border mode (default: clamp). More...
void | InterpolateRow (vtkInterpolationWeights *&weights, int xIdx, int yIdx, int zIdx, double *value, int n)
| Get a row of samples, using the weights that were precomputed by PrecomputeWeightsForExtent. More...
void | InterpolateRow (vtkInterpolationWeights *&weights, int xIdx, int yIdx, int zIdx, float *value, int n)
| Get a row of samples, using the weights that were precomputed by PrecomputeWeightsForExtent. More...
virtual double * | GetSpacing ()
| Get the spacing of the data being interpolated. More...
virtual void | GetSpacing (double &, double &, double &)
| Get the spacing of the data being interpolated. More...
virtual void | GetSpacing (double[3])
| Get the spacing of the data being interpolated. More...
virtual double * | GetDirection ()
| Get the direction of the data being interpolated. More...
virtual void | GetDirection (double data[9])
| Get the direction of the data being interpolated. More...
virtual double * | GetOrigin ()
| Get the origin of the data being interpolated. More...
virtual void | GetOrigin (double &, double &, double &)
| Get the origin of the data being interpolated. More...
virtual void | GetOrigin (double[3])
| Get the origin of the data being interpolated. More...
virtual int * | GetExtent ()
| Get the extent of the data being interpolated. More...
virtual void | GetExtent (int &, int &, int &, int &, int &, int &)
| Get the extent of the data being interpolated. More...
virtual void | GetExtent (int[6])
| Get the extent of the data being interpolated. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkImageSincInterpolator * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkImageSincInterpolator * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkAbstractImageInterpolator
static vtkTypeBool | IsTypeOf (const char *type)
static vtkAbstractImageInterpolator * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkImageSincInterpolator ()
| ~vtkImageSincInterpolator () override
void | InternalUpdate () override
| Update the interpolator. More...
void | InternalDeepCopy (vtkAbstractImageInterpolator *obj) override
| Copy the interpolator. More...
virtual void | BuildKernelLookupTable ()
| Build the lookup tables used for the interpolation. More...
virtual void | FreeKernelLookupTable ()
| Free the kernel lookup tables. More...
void | GetInterpolationFunc (void(**doublefunc)(vtkInterpolationInfo *, const double[3], double *)) override
| Get the interpolation functions. More...
void | GetInterpolationFunc (void(**floatfunc)(vtkInterpolationInfo *, const float[3], float *)) override
| Get the interpolation functions. More...
void | GetRowInterpolationFunc (void(**doublefunc)(vtkInterpolationWeights *, int, int, int, double *, int)) override
| Get the row interpolation functions. More...
void | GetRowInterpolationFunc (void(**floatfunc)(vtkInterpolationWeights *, int, int, int, float *, int)) override
| Get the row interpolation functions. More...
Protected Member Functions inherited from vtkAbstractImageInterpolator
| vtkAbstractImageInterpolator ()
| ~vtkAbstractImageInterpolator () override
void | CoordinateToIJK (const double point[3], double ijk[3])
| Convert XYZ coordinate to IJK continuous index. More...
virtual void | GetSlidingWindowFunc (void(**doublefunc)(vtkInterpolationWeights *, int, int, int, double *, int))
| Get the sliding window interpolation functions. More...
virtual void | GetSlidingWindowFunc (void(**floatfunc)(vtkInterpolationWeights *, int, int, int, float *, int))
| Get the sliding window interpolation functions. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
int | WindowFunction
int | WindowHalfWidth
float * | KernelLookupTable [3]
int | KernelSize [3]
int | Antialiasing
int | Renormalization
double | BlurFactors [3]
double | LastBlurFactors [3]
double | WindowParameter
int | UseWindowParameter
Protected Attributes inherited from vtkAbstractImageInterpolator
vtkDataArray * | Scalars
double | StructuredBoundsDouble [6]
float | StructuredBoundsFloat [6]
int | Extent [6]
double | Spacing [3]
double | Direction [9]
double | InverseDirection [9]
double | Origin [3]
double | OutValue
double | Tolerance
vtkImageBorderMode | BorderMode
int | ComponentOffset
int | ComponentCount
bool | UseDirection
bool | SlidingWindow
vtkInterpolationInfo * | InterpolationInfo
void(* | InterpolationFuncDouble )(vtkInterpolationInfo *info, const double point[3], double *outPtr)
void(* | InterpolationFuncFloat )(vtkInterpolationInfo *info, const float point[3], float *outPtr)
void(* | RowInterpolationFuncDouble )(vtkInterpolationWeights *weights, int idX, int idY, int idZ, double *outPtr, int n)
void(* | RowInterpolationFuncFloat )(vtkInterpolationWeights *weights, int idX, int idY, int idZ, float *outPtr, int n)
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

perform sinc interpolation on images

vtkImageSincInterpolator provides various windowed sinc interpolation methods for image data. The default is a five-lobed Lanczos interpolant, with a kernel size of 6. The interpolator can also bandlimit the image, which can be used for antialiasing. The interpolation kernels are evaluated via a lookup table for efficiency.

Thanks:
  Thanks to David Gobbi at the Seaman Family MR Centre and Dept. of Clinical Neurosciences, Foothills Medical Centre, Calgary, for providing this class.

See also
  vtkImageReslice

Examples:
  vtkImageSincInterpolator (Examples)

Online Examples:

Tests:
  vtkImageSincInterpolator (Tests)

Definition at line 57 of file vtkImageSincInterpolator.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkAbstractImageInterpolator vtkImageSincInterpolator::Superclass

Definition at line 61 of file vtkImageSincInterpolator.h.

## Constructor & Destructor Documentation

## ◆ vtkImageSincInterpolator()

vtkImageSincInterpolator::vtkImageSincInterpolator | ( |  | ) |
| protected

## ◆ ~vtkImageSincInterpolator()

vtkImageSincInterpolator::~vtkImageSincInterpolator | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkImageSincInterpolator* vtkImageSincInterpolator::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkImageSincInterpolator::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkImageSincInterpolator::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkAbstractImageInterpolator.

## ◆ SafeDownCast()

static vtkImageSincInterpolator* vtkImageSincInterpolator::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkImageSincInterpolator::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkAbstractImageInterpolator.

## ◆ NewInstance()

vtkImageSincInterpolator* vtkImageSincInterpolator::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkImageSincInterpolator::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkAbstractImageInterpolator.

## ◆ SetWindowFunction()

virtual void vtkImageSincInterpolator::SetWindowFunction | ( | int | mode | ) |
| virtual

The window function to use.

The default is Lanczos, which is very popular and performs well with a kernel width of 6. The Cosine window is included for historical reasons. All other windows are described in AH Nuttall, "Some windows with very good sidelobe behavior," IEEE Transactions on Acoustics, Speech, and Signal Processing 29:84-91, 1981.

## ◆ SetWindowFunctionToLanczos()

void vtkImageSincInterpolator::SetWindowFunctionToLanczos | ( |  | ) |
| inline

The window function to use.

The default is Lanczos, which is very popular and performs well with a kernel width of 6. The Cosine window is included for historical reasons. All other windows are described in AH Nuttall, "Some windows with very good sidelobe behavior," IEEE Transactions on Acoustics, Speech, and Signal Processing 29:84-91, 1981.

Definition at line 74 of file vtkImageSincInterpolator.h.

## ◆ SetWindowFunctionToKaiser()

void vtkImageSincInterpolator::SetWindowFunctionToKaiser | ( |  | ) |
| inline

The window function to use.

The default is Lanczos, which is very popular and performs well with a kernel width of 6. The Cosine window is included for historical reasons. All other windows are described in AH Nuttall, "Some windows with very good sidelobe behavior," IEEE Transactions on Acoustics, Speech, and Signal Processing 29:84-91, 1981.

Definition at line 75 of file vtkImageSincInterpolator.h.

## ◆ SetWindowFunctionToCosine()

void vtkImageSincInterpolator::SetWindowFunctionToCosine | ( |  | ) |
| inline

The window function to use.

The default is Lanczos, which is very popular and performs well with a kernel width of 6. The Cosine window is included for historical reasons. All other windows are described in AH Nuttall, "Some windows with very good sidelobe behavior," IEEE Transactions on Acoustics, Speech, and Signal Processing 29:84-91, 1981.

Definition at line 76 of file vtkImageSincInterpolator.h.

## ◆ SetWindowFunctionToHann()

void vtkImageSincInterpolator::SetWindowFunctionToHann | ( |  | ) |
| inline

The window function to use.

The default is Lanczos, which is very popular and performs well with a kernel width of 6. The Cosine window is included for historical reasons. All other windows are described in AH Nuttall, "Some windows with very good sidelobe behavior," IEEE Transactions on Acoustics, Speech, and Signal Processing 29:84-91, 1981.

Definition at line 77 of file vtkImageSincInterpolator.h.

## ◆ SetWindowFunctionToHamming()

void vtkImageSincInterpolator::SetWindowFunctionToHamming | ( |  | ) |
| inline

The window function to use.

The default is Lanczos, which is very popular and performs well with a kernel width of 6. The Cosine window is included for historical reasons. All other windows are described in AH Nuttall, "Some windows with very good sidelobe behavior," IEEE Transactions on Acoustics, Speech, and Signal Processing 29:84-91, 1981.

Definition at line 78 of file vtkImageSincInterpolator.h.

## ◆ SetWindowFunctionToBlackman()

void vtkImageSincInterpolator::SetWindowFunctionToBlackman | ( |  | ) |
| inline

The window function to use.

The default is Lanczos, which is very popular and performs well with a kernel width of 6. The Cosine window is included for historical reasons. All other windows are described in AH Nuttall, "Some windows with very good sidelobe behavior," IEEE Transactions on Acoustics, Speech, and Signal Processing 29:84-91, 1981.

Definition at line 79 of file vtkImageSincInterpolator.h.

## ◆ SetWindowFunctionToBlackmanHarris3()

void vtkImageSincInterpolator::SetWindowFunctionToBlackmanHarris3 | ( |  | ) |
| inline

The window function to use.

The default is Lanczos, which is very popular and performs well with a kernel width of 6. The Cosine window is included for historical reasons. All other windows are described in AH Nuttall, "Some windows with very good sidelobe behavior," IEEE Transactions on Acoustics, Speech, and Signal Processing 29:84-91, 1981.

Definition at line 80 of file vtkImageSincInterpolator.h.

## ◆ SetWindowFunctionToBlackmanHarris4()

void vtkImageSincInterpolator::SetWindowFunctionToBlackmanHarris4 | ( |  | ) |
| inline

The window function to use.

The default is Lanczos, which is very popular and performs well with a kernel width of 6. The Cosine window is included for historical reasons. All other windows are described in AH Nuttall, "Some windows with very good sidelobe behavior," IEEE Transactions on Acoustics, Speech, and Signal Processing 29:84-91, 1981.

Definition at line 81 of file vtkImageSincInterpolator.h.

## ◆ SetWindowFunctionToNuttall()

void vtkImageSincInterpolator::SetWindowFunctionToNuttall | ( |  | ) |
| inline

The window function to use.

The default is Lanczos, which is very popular and performs well with a kernel width of 6. The Cosine window is included for historical reasons. All other windows are described in AH Nuttall, "Some windows with very good sidelobe behavior," IEEE Transactions on Acoustics, Speech, and Signal Processing 29:84-91, 1981.

Definition at line 82 of file vtkImageSincInterpolator.h.

## ◆ SetWindowFunctionToBlackmanNuttall3()

void vtkImageSincInterpolator::SetWindowFunctionToBlackmanNuttall3 | ( |  | ) |
| inline

The window function to use.

The default is Lanczos, which is very popular and performs well with a kernel width of 6. The Cosine window is included for historical reasons. All other windows are described in AH Nuttall, "Some windows with very good sidelobe behavior," IEEE Transactions on Acoustics, Speech, and Signal Processing 29:84-91, 1981.

Definition at line 83 of file vtkImageSincInterpolator.h.

## ◆ SetWindowFunctionToBlackmanNuttall4()

void vtkImageSincInterpolator::SetWindowFunctionToBlackmanNuttall4 | ( |  | ) |
| inline

The window function to use.

The default is Lanczos, which is very popular and performs well with a kernel width of 6. The Cosine window is included for historical reasons. All other windows are described in AH Nuttall, "Some windows with very good sidelobe behavior," IEEE Transactions on Acoustics, Speech, and Signal Processing 29:84-91, 1981.

Definition at line 84 of file vtkImageSincInterpolator.h.

## ◆ GetWindowFunction()

int vtkImageSincInterpolator::GetWindowFunction | ( |  | ) |
| inline

The window function to use.

The default is Lanczos, which is very popular and performs well with a kernel width of 6. The Cosine window is included for historical reasons. All other windows are described in AH Nuttall, "Some windows with very good sidelobe behavior," IEEE Transactions on Acoustics, Speech, and Signal Processing 29:84-91, 1981.

Definition at line 85 of file vtkImageSincInterpolator.h.

## ◆ GetWindowFunctionAsString()

virtual const char* vtkImageSincInterpolator::GetWindowFunctionAsString | ( |  | ) |
| virtual

The window function to use.

The default is Lanczos, which is very popular and performs well with a kernel width of 6. The Cosine window is included for historical reasons. All other windows are described in AH Nuttall, "Some windows with very good sidelobe behavior," IEEE Transactions on Acoustics, Speech, and Signal Processing 29:84-91, 1981.

## ◆ SetWindowHalfWidth()

void vtkImageSincInterpolator::SetWindowHalfWidth | ( | int | n | ) |

Set the window half-width, this must be an integer between 1 and 16, with a default value of 3.

The kernel size will be twice this value if no blur factors are applied. The total number of sinc lobes will be one less than twice the half-width, so if the half-width is 3 then the kernel size will be 6 and there will be 5 sinc lobes.

## ◆ GetWindowHalfWidth()

int vtkImageSincInterpolator::GetWindowHalfWidth | ( |  | ) |
| inline

Definition at line 97 of file vtkImageSincInterpolator.h.

## ◆ SetUseWindowParameter()

void vtkImageSincInterpolator::SetUseWindowParameter | ( | int | val | ) |

Turn this on in order to use SetWindowParameter.

If it is off, then the default parameter will be used for the window.

## ◆ UseWindowParameterOn()

void vtkImageSincInterpolator::UseWindowParameterOn | ( |  | ) |
| inline

Definition at line 104 of file vtkImageSincInterpolator.h.

## ◆ UseWindowParameterOff()

void vtkImageSincInterpolator::UseWindowParameterOff | ( |  | ) |
| inline

Definition at line 105 of file vtkImageSincInterpolator.h.

## ◆ GetUseWindowParameter()

int vtkImageSincInterpolator::GetUseWindowParameter | ( |  | ) |
| inline

Definition at line 106 of file vtkImageSincInterpolator.h.

## ◆ SetWindowParameter()

void vtkImageSincInterpolator::SetWindowParameter | ( | double | parm | ) |

Set the alpha parameter for the Kaiser window function.

This parameter will be ignored unless UseWindowParameter is On. If UseWindowParameter is Off, then alpha is set to be the same as n where n is the window half-width. Using an alpha less than n increases the sharpness and ringing, while using an alpha greater than n increases the blurring.

## ◆ GetWindowParameter()

double vtkImageSincInterpolator::GetWindowParameter | ( |  | ) |
| inline

Definition at line 117 of file vtkImageSincInterpolator.h.

## ◆ ComputeSupportSize()

void vtkImageSincInterpolator::ComputeSupportSize | ( | const double | matrix[16],
|  | int | support[3]
| ) |  |
| overridevirtual

Get the support size for use in computing update extents.

If the data will be sampled on a regular grid, then pass a matrix describing the structured coordinate transformation between the output and the input. Otherwise, pass nullptr as the matrix to retrieve the full kernel size.

Implements vtkAbstractImageInterpolator.

## ◆ SetBlurFactors() [1/2]

void vtkImageSincInterpolator::SetBlurFactors | ( | double | x,
|  | double | y,
|  | double | z
| ) |  |

Blur the image by widening the windowed sinc kernel by the specified factors for the x, y, and z directions.

This reduces the bandwidth by these same factors. If you turn Antialiasing on, then the blur factors will be computed automatically from the output sampling rate. Blurring increases the computation time because the kernel size increases by the blur factor.

## ◆ SetBlurFactors() [2/2]

void vtkImageSincInterpolator::SetBlurFactors | ( | const double | f[3] | ) |
| inline

Blur the image by widening the windowed sinc kernel by the specified factors for the x, y, and z directions.

This reduces the bandwidth by these same factors. If you turn Antialiasing on, then the blur factors will be computed automatically from the output sampling rate. Blurring increases the computation time because the kernel size increases by the blur factor.

Definition at line 137 of file vtkImageSincInterpolator.h.

## ◆ GetBlurFactors() [1/2]

void vtkImageSincInterpolator::GetBlurFactors | ( | double | f[3] | ) |
| inline

Blur the image by widening the windowed sinc kernel by the specified factors for the x, y, and z directions.

This reduces the bandwidth by these same factors. If you turn Antialiasing on, then the blur factors will be computed automatically from the output sampling rate. Blurring increases the computation time because the kernel size increases by the blur factor.

Definition at line 138 of file vtkImageSincInterpolator.h.

## ◆ GetBlurFactors() [2/2]

double* vtkImageSincInterpolator::GetBlurFactors | ( |  | ) |
| inline

Blur the image by widening the windowed sinc kernel by the specified factors for the x, y, and z directions.

This reduces the bandwidth by these same factors. If you turn Antialiasing on, then the blur factors will be computed automatically from the output sampling rate. Blurring increases the computation time because the kernel size increases by the blur factor.

Definition at line 144 of file vtkImageSincInterpolator.h.

## ◆ SetAntialiasing()

void vtkImageSincInterpolator::SetAntialiasing | ( | int | antialiasing | ) |

Turn on antialiasing.

If antialiasing is on, then the BlurFactors will be computed automatically from the output sampling rate such that that the image will be bandlimited to the Nyquist frequency. This is only applicable when the interpolator is being used by a resampling filter like vtkImageReslice. Such a filter will indicate the output sampling by calling the interpolator's ComputeSupportSize() method, which will compute the blur factors at the same time that it computes the support size.

## ◆ AntialiasingOn()

void vtkImageSincInterpolator::AntialiasingOn | ( |  | ) |
| inline

Definition at line 158 of file vtkImageSincInterpolator.h.

## ◆ AntialiasingOff()

void vtkImageSincInterpolator::AntialiasingOff | ( |  | ) |
| inline

Definition at line 159 of file vtkImageSincInterpolator.h.

## ◆ GetAntialiasing()

int vtkImageSincInterpolator::GetAntialiasing | ( |  | ) |
| inline

Definition at line 160 of file vtkImageSincInterpolator.h.

## ◆ SetRenormalization()

void vtkImageSincInterpolator::SetRenormalization | ( | int | renormalization | ) |

Turn off renormalization.

Most of the sinc windows provide kernels for which the weights do not sum to one, and for which the sum depends on the offset. This results in small ripple artifacts in the output. By default, the vtkImageSincInterpolator will renormalize these kernels. This method allows the renormalization to be turned off.

## ◆ RenormalizationOn()

void vtkImageSincInterpolator::RenormalizationOn | ( |  | ) |
| inline

Definition at line 170 of file vtkImageSincInterpolator.h.

## ◆ RenormalizationOff()

void vtkImageSincInterpolator::RenormalizationOff | ( |  | ) |
| inline

Definition at line 171 of file vtkImageSincInterpolator.h.

## ◆ GetRenormalization()

int vtkImageSincInterpolator::GetRenormalization | ( |  | ) |
| inline

Definition at line 172 of file vtkImageSincInterpolator.h.

## ◆ IsSeparable()

bool vtkImageSincInterpolator::IsSeparable | ( |  | ) |
| overridevirtual

Returns true if the interpolator supports weight precomputation.

This will always return true for this interpolator.

Implements vtkAbstractImageInterpolator.

## ◆ PrecomputeWeightsForExtent() [1/2]

void vtkImageSincInterpolator::PrecomputeWeightsForExtent | ( | const double | matrix[16],
|  | const int | extent[6],
|  | int | newExtent[6],
|  | vtkInterpolationWeights *& | weights
| ) |  |
| overridevirtual

If the data is going to be sampled on a regular grid, then the interpolation weights can be precomputed.

A matrix must be supplied that provides a transformation between the provided extent and the structured coordinates of the input. This matrix must perform only permutations, scales, and translation, i.e. each of the three columns must have only one non-zero value. A new extent is provided for out-of-bounds checks. THIS METHOD IS THREAD SAFE.

Reimplemented from vtkAbstractImageInterpolator.

## ◆ PrecomputeWeightsForExtent() [2/2]

void vtkImageSincInterpolator::PrecomputeWeightsForExtent | ( | const float | matrix[16],
|  | const int | extent[6],
|  | int | newExtent[6],
|  | vtkInterpolationWeights *& | weights
| ) |  |
| overridevirtual

If the data is going to be sampled on a regular grid, then the interpolation weights can be precomputed.

A matrix must be supplied that provides a transformation between the provided extent and the structured coordinates of the input. This matrix must perform only permutations, scales, and translation, i.e. each of the three columns must have only one non-zero value. A new extent is provided for out-of-bounds checks. THIS METHOD IS THREAD SAFE.

Reimplemented from vtkAbstractImageInterpolator.

## ◆ FreePrecomputedWeights()

void vtkImageSincInterpolator::FreePrecomputedWeights | ( | vtkInterpolationWeights *& | weights | ) |
| overridevirtual

Free the precomputed weights.

THIS METHOD IS THREAD SAFE.

Reimplemented from vtkAbstractImageInterpolator.

## ◆ InternalUpdate()

void vtkImageSincInterpolator::InternalUpdate | ( |  | ) |
| overrideprotectedvirtual

Update the interpolator.

Implements vtkAbstractImageInterpolator.

## ◆ InternalDeepCopy()

void vtkImageSincInterpolator::InternalDeepCopy | ( | vtkAbstractImageInterpolator * | obj | ) |
| overrideprotectedvirtual

Copy the interpolator.

Implements vtkAbstractImageInterpolator.

## ◆ GetInterpolationFunc() [1/2]

void vtkImageSincInterpolator::GetInterpolationFunc | ( | void(**)(vtkInterpolationInfo *, const double[3], double *) | doublefunc | ) |
| overrideprotectedvirtual

Get the interpolation functions.

Reimplemented from vtkAbstractImageInterpolator.

## ◆ GetInterpolationFunc() [2/2]

void vtkImageSincInterpolator::GetInterpolationFunc | ( | void(**)(vtkInterpolationInfo *, const float[3], float *) | floatfunc | ) |
| overrideprotectedvirtual

Get the interpolation functions.

Reimplemented from vtkAbstractImageInterpolator.

## ◆ GetRowInterpolationFunc() [1/2]

void vtkImageSincInterpolator::GetRowInterpolationFunc | ( | void(**)(vtkInterpolationWeights *, int, int, int, double *, int) | doublefunc | ) |
| overrideprotectedvirtual

Get the row interpolation functions.

Reimplemented from vtkAbstractImageInterpolator.

## ◆ GetRowInterpolationFunc() [2/2]

void vtkImageSincInterpolator::GetRowInterpolationFunc | ( | void(**)(vtkInterpolationWeights *, int, int, int, float *, int) | floatfunc | ) |
| overrideprotectedvirtual

Get the row interpolation functions.

Reimplemented from vtkAbstractImageInterpolator.

## ◆ BuildKernelLookupTable()

virtual void vtkImageSincInterpolator::BuildKernelLookupTable | ( |  | ) |
| protectedvirtual

Build the lookup tables used for the interpolation.

## ◆ FreeKernelLookupTable()

virtual void vtkImageSincInterpolator::FreeKernelLookupTable | ( |  | ) |
| protectedvirtual

Free the kernel lookup tables.

## Member Data Documentation

## ◆ WindowFunction

int vtkImageSincInterpolator::WindowFunction
| protected

Definition at line 246 of file vtkImageSincInterpolator.h.

## ◆ WindowHalfWidth

int vtkImageSincInterpolator::WindowHalfWidth
| protected

Definition at line 247 of file vtkImageSincInterpolator.h.

## ◆ KernelLookupTable

float* vtkImageSincInterpolator::KernelLookupTable[3]
| protected

Definition at line 248 of file vtkImageSincInterpolator.h.

## ◆ KernelSize

int vtkImageSincInterpolator::KernelSize[3]
| protected

Definition at line 249 of file vtkImageSincInterpolator.h.

## ◆ Antialiasing

int vtkImageSincInterpolator::Antialiasing
| protected

Definition at line 250 of file vtkImageSincInterpolator.h.

## ◆ Renormalization

int vtkImageSincInterpolator::Renormalization
| protected

Definition at line 251 of file vtkImageSincInterpolator.h.

## ◆ BlurFactors

double vtkImageSincInterpolator::BlurFactors[3]
| protected

Definition at line 252 of file vtkImageSincInterpolator.h.

## ◆ LastBlurFactors

double vtkImageSincInterpolator::LastBlurFactors[3]
| protected

Definition at line 253 of file vtkImageSincInterpolator.h.

## ◆ WindowParameter

double vtkImageSincInterpolator::WindowParameter
| protected

Definition at line 254 of file vtkImageSincInterpolator.h.

## ◆ UseWindowParameter

int vtkImageSincInterpolator::UseWindowParameter
| protected

Definition at line 255 of file vtkImageSincInterpolator.h.

The documentation for this class was generated from the following file:

- Imaging/Core/vtkImageSincInterpolator.h